package java.lang;

import java.security.AccessController;
import java.security.PrivilegedAction;

public final class Compiler
{
    private Compiler() {
    }
    
    private static native void initialize();
    
    private static native void registerNatives();
    
    public static native boolean compileClass(Class<?> p0);
    
    public static native boolean compileClasses(String p0);
    
    public static native Object command(Object p0);
    
    public static native void enable();
    
    public static native void disable();
    
    static void access$000() {
        initialize();
    }
    
    static {
        registerNatives();
        AccessController.doPrivileged(new PrivilegedAction<Void>() {
            @Override
            public Void run() {
                boolean n = false;
                String property = System.getProperty("java.compiler");
                if (property != null && !property.equals("NONE") && !property.equals("")) {
                    try {
                        System.loadLibrary(property);
                        Compiler.access$000();
                        n = true;
                    }
                    catch (UnsatisfiedLinkError unsatisfiedLinkError) {
                        System.err.println("Warning: JIT compiler \"" + property + "\" not found. Will use interpreter.");
                    }
                }
                String property2 = System.getProperty("java.vm.info");
                if (!(n == 0)) {
                    System.setProperty("java.vm.info", property2 + ", " + property);
                }
                else {
                    System.setProperty("java.vm.info", property2 + ", nojit");
                }
                return null;
            }
        });
    }
}
